;
; Small C runtime for multiplication, division (broken), switch
; --- SIGNED CRAP ---
;
;


#ifdef inc_mult
;===========================================================================;
; INC_MULT
; HL = DE * HL
;===========================================================================;
_mul:           ld              b,h
                ld              c,l             ; bc = hl
                ld              hl,0
_mul1           add             hl,de           
                dec             bc              
                ld              a,b             ;
                or              a               ;
                jp              nz,_mul1        ;
                ld              a,c             ;
                or              a               ;
                jp              nz,_mul1        ; 
                ret                             ; if (bc==0) ret
                
;===========================================================================;
#endif


#ifdef inc_div
;===========================================================================;
; HL = DE / HL, DE = DE % HL
; this _was_ a signed division, i've removed () what appears to be the neg
; operations (but it probably ain't perfect)
; credit: small c
;===========================================================================;
_div:           ld              b,h
                ld              c,l
                ld              a,d
                xor             b
                push            af
     ;          ld              a,d
     ;          or              a
     ;          call            m,_deneg           
     ;          ld              a,b
     ;          or              a
     ;          call            m,_bcneg           
                ld              a,16
                push            af
                ex              de,hl
                ld              de,0
_div1:          add             hl,hl
                call            _rdel
                jr              z,_div2
                call            _cmpbd
                jp              m,_div2
                ld              a,l
                or              1
                ld              l,a
                ld              a,e
                sub             c
                ld              e,a
                ld              a,d
                sbc             a,b
                ld              d,a
_div2:          pop             af
                dec             a
                jr              z,_div3
                push            af
                jr              _div1
_div3:          pop             af
      ;         ret             p
      ;         call            _deneg             
      ;         ex              de,hl              
      ;         call            _deneg             
      ;         ex              de,hl              
                ret

;===========================================================================;
; {DE <r<r 1}
;===========================================================================;
_rdel:          ld              a,e
                rla
                ld              e,a
                ld              a,d
                rla
                ld              d,a
                or              e
                ret


;===========================================================================;
; {BC : DE}
;===========================================================================;
_cmpbd:         ld              a,e
                sub             c
                ld              a,d
                sbc             a,b
                ret
#endif


#ifdef inc_case       
;===========================================================================;
; INC_CASE
;===========================================================================;
_case:          ex              de,hl           ;switch value to DE
                pop             hl              ;get table address
_case1:         call            _case4          ;get case value
                ld              a,e
                cp              c               ;equal to switch value .
                jr              nz,_case2       ;no
                ld              a,d
                cp              b               ;equal to switch value .
                jr              nz,_case2       ;no
                call            _case4          ;get case label
                jr              z,_case3        ;end of table, go to default

                push            bc
                ret                             ;case jump

_case2:         call            _case4          ;get case label
                jr              nz,_case1       ;next case
_case3:         dec             hl
                dec             hl
                dec             hl
                ld              d,(hl)
                dec             hl
                ld              e,(hl)
                ex              de,hl
                           
                jp              (hl)                    ;default jump

_case4:         ld              c,(hl)
                inc             hl
                ld              b,(hl)
                inc             hl
                ld              a,c
                or              b
                ret
#endif
