#include "system.h"
#include "key.h"
#include "crt.h"
#include "libgm\graph.h"
#include "lib\sprite_x.c"
#include "lib\hvline.c"

extern char track[];
extern char player[3];
extern char brick[8];

int px,py,pz;
int tx,ty;

main() {
   graphpage;

   px = 38;
   pz = 0;
   bufclr();

   hline(0, 96, 34);

   while (1) {
      putpixelm(track[pz]-10,32);
      putpixelm(track[pz]-11,32);

      putpixelm(track[pz]+10,32);
      putpixelm(track[pz]+11,32);

      for (tx=0;tx<10;tx++) {
         sprite_x(player,px,4,8,3);
         cr_grbcopy;
         sprite_x(player,px,4,8,3);
      
         switch (kbhit()) {
            case K_LEFT  : px-=2;
                          break;
            case K_RIGHT : px+=2;
                        break;
            case K_MODE  : exit;
         }
      }

      #asm
        LD  DE, GRAPH_MEM+$2ff
        LD  HL, GRAPH_MEM+$2ff-$c
        LD  BC, $180+$c                   ; half screen + 1
        LDDR
      #endasm

//    for (ty=GRAPH_MEM+$;ty<33;ty+12+) {

      pz++;
      if (track[pz]==0) pz=0;
   }
}

#asm
player          .db             %11111111
                .db             %01111110
                .db             %00011000



track           .db             46
                .db             46
                .db             46
                .db             46
                .db             46
                .db             46
                .db             47
                .db             48
                .db             49
                .db             50
                .db             51
                .db             52
                .db             53
                .db             54
                .db             55

                .db             0


#endasm


