/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   inlines.h                      07/nov/98             lord_nexus@usa.net
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   system/hardware related
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */

#ifndef SYSTEM_H
#define SYSTEM_H

/* --- contants ---------------------------------------------------------- */

/* --- variables --------------------------------------------------------- */

extern int  _apd_free  (0x8d70);
extern char _int_state (0x8d72);
extern char _crash_ver (0x8d73);

/* --- defines ----------------------------------------------------------- */

/* Turn the busy indicator on and off */
#define busyon   asm("\tROM_CALL(BUSY_ON)\n")
#define busyoff  asm("\tROM_CALL(BUSY_OFF)\n")

/* interrupt control */
#define ei asm("\tei\n")
#define di asm("\tdi\n")

/* interrupt speed */
#define int_normal  asm("\tld a,%00000110\n\tout (4),a\n")
#define int_medium  asm("\tld a,%00000100\n\tout (4),a\n")
#define int_fast    asm("\tld a,%00000010\n\tout (4),a\n")
#define int_fastest asm("\tld a,%00000000\n\tout (4),a\n")

#define calcoff  asm("\tROM_CALL")

/* boss - return to home screen */
#define boss asm("\tjp BOSS_FUNC\n")
/* exit -- return to shell */
#define exit asm("\tjp _cleanup\n")

/* --- functions --------------------------------------------------------- */

#endif /* SYSTEM.H */
