;
; Small C runtime for multiplication, division (broken), switch
; --- SIGNED CRAP ---
;
;


;===========================================================================;
; INC_MULT
;===========================================================================;
#ifdef inc_mult
; HL = DE * HL [signed]
_mul: ld b,h
	ld	c,l
        ld hl,0
_mul1:   ld a,c
	rrca
        jr nc,_mul2
	add	hl,de
_mul2:   xor   a
	ld	a,b
	rra
	ld	b,a
	ld	a,c
	rra
	ld	c,a
	or	b
	ret	z
	xor	a
	ld	a,e
	rla
	ld	e,a
	ld	a,d
	rla
	ld	d,a
	or	e
	ret	z
        jr _mul1
#endif


;===========================================================================;
; INC_DIV
;===========================================================================;
#ifdef inc_div
cm_de:
   ld a,d
   or a
   ret p
   call _deneg
   ret
cm_bc:
   ld a,b
   or a
   ret p
   call _bcneg
   ret
; HL = DE / HL, DE = DE % HL
_div: ld b,h
	ld	c,l
	ld	a,d
	xor	b
	push	af
   ;call  m,_deneg             ; ZShell mod
   call cm_de
   ;was - call  m,_bcneg       ; ZShell mod
   call cm_bc
   ld a,16
	push	af
	ex	de,hl
   ld de,0
_div1:   add   hl,hl
; {DE <r<r 1}
_rdel:   ld a,e
	rla
	ld	e,a
	ld	a,d
	rla
	ld	d,a
	or	e
   jr z,_div2
; {BC : DE}
_cmpbd: ld  a,e
	sub	c
	ld	a,d
	sbc	a,b
   ;was - jp m,_div2               ; smallc
   ; JUMP_C(_div2)                ; ZShell mod
        jp m,_div2                 ; ACC 
	ld	a,l
   or 1
	ld	l,a
	ld	a,e
	sub	c
	ld	e,a
	ld	a,d
	sbc	a,b
	ld	d,a
_div2:   pop   af
	dec	a
        jr z,_div3
	push	af
        jr _div1
_div3:   pop   af
	ret	p
        call _deneg
	ex	de,hl
        call _deneg
	ex	de,hl
	ret
; {DE = -DE}
_deneg: ld  a,d
	cpl
	ld	d,a
	ld	a,e
	cpl
	ld	e,a
	inc	de
	ret
; {BC = -BC}
_bcneg: ld  a,b
	cpl
	ld	b,a
	ld	a,c
	cpl
	ld	c,a
	inc	bc
	ret
#endif


;===========================================================================;
; INC_CASE
;===========================================================================;
#ifdef inc_case
; case jump
_case:   ex de,hl       ;switch value to DE
	pop	hl		;get table address
_case1:  call _case4      ;get case value
	ld	a,e
	cp	c		;equal to switch value .
        jr nz,_case2   ;no
	ld	a,d
	cp	b		;equal to switch value .
        jr nz,_case2   ;no
        call _case4       ;get case label
        jr z,_case3 ;end of table, go to default
;      ld hl,(PROGRAM_ADDR)    ; ZShell modification
        ld hl, 0               ; ash mods
        add hl,bc
        push  hl
	ret			;case jump
_case2:  call _case4      ;get case label
        jr nz,_case1   ;next case
_case3:  dec   hl
	dec	hl
	dec	hl
	ld	d,(hl)
	dec	hl
	ld	e,(hl)
	ex	de,hl
                           ; ZShell modification
;      ld bc,(PROGRAM_ADDR)    ; bc contains no useful info (I think)
;      add hl,bc

                ; ash mods (nill)

        jp   (hl)            ;default jump
_case4:  ld c,(hl)
	inc	hl
	ld	b,(hl)
	inc	hl
	ld	a,c
	or	b
	ret
#endif
