@echo off
if "%1"=="" goto err_use

cpp -P -I. %1.c > _temp~.c
if errorlevel 1 goto err_cpp
acc _temp~.c
if errorlevel 1 goto err_acc
tasm -80 -b -r16 _temp~.asm %1.obj
if errorlevel 1 goto err_tasm
crprgm82 %1
fix %1.82p

if exist _temp~.c del _temp~.c
if exist _temp~.asm del _temp~.asm
if exist _temp~.lst del _temp~.lst
if exist %1.asm del %1.asm
if exist %1.lst del %1.lst
if exist %1.obj del %1.obj
goto exit

:err_use
echo ti82 ash c compiler (using gnu cpp)
echo usage: cc.bat filename
goto exit


:err_cpp
echo errors
goto exit

:err_acc
echo errors
goto exit

:err_tasm
echo errors
goto exit

:exit
