#ifndef TABLN_C
#define TABLN_C

/* Small c library, by Jeremy Dewey (jxd45@po.cwru.edu)
   http://www.seashellinc.com/~jdewey

   Synopsis:
      tabline(char* title)

   Description:
      Draws a line across the top of the screen and a tab with a title at the
      top left (similar to a PalmOS window).

   Example:
      tabline("PalmOS");

   Notes:
      see also tabframe.c

*/

#include "lib\hvline.c"

tabline(str) char* str; {
   char y;
   invtext;
   setxy_m(2,1);
   puts_m(str);
   hline(1, _menu_x, 63);
   for (y=62; y>55; y--) hline(0, _menu_x+1, y);
   hline(0,127,55);
}

#endif
